#!/usr/bin/env python3

from pyspark import SparkConf, SparkContext
from movie import Movie, Person, Role




#conf = SparkConf().setAppName("Exercice 3.3").setMaster("spark://a-139160.ups.u-psud.fr:7077")
conf = SparkConf().setAppName("Exercice 3.3").setMaster("local")

sc = SparkContext(conf=conf)
##REMPLACER /user/kim/input par /user/VOTRELOGIN/input

def mkMovie(s):
   l = s.split(";")
   return Movie(l[0], l[1], l[2], l[3], l[4])

def mkPerson(s):
   l = s.split(";")
   return Person(l[0], l[1], l[2])

def mkRole(s):
   l = s.split(";")
   return Role(l[0], l[1], l[2])



lines = sc.textFile("hdfs://localhost:9000/user/kim/input/movie.txt")
movies = lines.map(mkMovie).map(lambda m: (m.id, m))

lines = sc.textFile("hdfs://localhost:9000/user/kim/input/people.txt")
people = lines.map(mkPerson).map(lambda p: (p.id, p))

lines = sc.textFile("hdfs://localhost:9000/user/kim/input/role.txt")
roles = lines.map(mkRole).map(lambda r: (r.idMovie, r)) 

movieRoles = movies.join(roles) \
                    .map(lambda p: (p[1][1].idPerson,p[1])).cache()

moviesRolesPeople = movieRoles.join(people).map(lambda p: (p[1][0][0],p[1][0][1], p[1][1]))

print(moviesRolesPeople.toDebugString().decode("utf-8"))
#print (moviesRoles.count())
#print (moviesRolesPeople.count())
#for (m,r,p) in moviesRolesPeople.collect():
#   print(m.title, ":", r.role, "=>", p.firstname, p.lastname)







